#include <diagnostic_msgs/boost/KeyValue.h>
#include "ros_msg_transporter.hpp"
#include "RosLib.hpp"
#include <rtt/types/TransportPlugin.hpp>
#include <rtt/types/TypekitPlugin.hpp>

namespace ros_integration {
  using namespace RTT;
    struct ROSKeyValuePlugin
      : public types::TransportPlugin
    {
      bool registerTransport(std::string name, types::TypeInfo* ti)
      {
	if(name == "/diagnostic_msgs/KeyValue")
	  return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<diagnostic_msgs::KeyValue>());
	return false;
      }
      
      std::string getTransportName() const {
	return "ros";
      }
      
      std::string getTypekitName() const {
	return std::string("ros-")+"KeyValue";
      }
      std::string getName() const {
	return std::string("rtt-ros-") + "KeyValue" + "-transport";
      }

    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSKeyValuePlugin )
