
#include <sensor_msgs/PointCloud.h>
#include <sensor_msgs/JoyFeedback.h>
#include <sensor_msgs/CameraInfo.h>
#include <sensor_msgs/PointField.h>
#include <sensor_msgs/Range.h>
#include <sensor_msgs/RegionOfInterest.h>
#include <sensor_msgs/LaserScan.h>
#include <sensor_msgs/Imu.h>
#include <sensor_msgs/Joy.h>
#include <sensor_msgs/CompressedImage.h>
#include <sensor_msgs/NavSatStatus.h>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/JoyFeedbackArray.h>
#include <sensor_msgs/Image.h>
#include <sensor_msgs/NavSatFix.h>
#include <sensor_msgs/ChannelFloat32.h>
#include <sensor_msgs/TimeReference.h>
#include <sensor_msgs/JointState.h>

#include "ros_msg_transporter.hpp"
#include "RosLib.hpp"
#include <rtt/types/TransportPlugin.hpp>
#include <rtt/types/TypekitPlugin.hpp>

namespace ros_integration {
  using namespace RTT;
    struct ROSsensor_msgsPlugin
      : public types::TransportPlugin
    {
      bool registerTransport(std::string name, types::TypeInfo* ti)
      {
                   if(name == "/sensor_msgs/PointCloud")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::PointCloud>());
         if(name == "/sensor_msgs/JoyFeedback")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::JoyFeedback>());
         if(name == "/sensor_msgs/CameraInfo")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::CameraInfo>());
         if(name == "/sensor_msgs/PointField")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::PointField>());
         if(name == "/sensor_msgs/Range")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::Range>());
         if(name == "/sensor_msgs/RegionOfInterest")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::RegionOfInterest>());
         if(name == "/sensor_msgs/LaserScan")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::LaserScan>());
         if(name == "/sensor_msgs/Imu")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::Imu>());
         if(name == "/sensor_msgs/Joy")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::Joy>());
         if(name == "/sensor_msgs/CompressedImage")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::CompressedImage>());
         if(name == "/sensor_msgs/NavSatStatus")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::NavSatStatus>());
         if(name == "/sensor_msgs/PointCloud2")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::PointCloud2>());
         if(name == "/sensor_msgs/JoyFeedbackArray")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::JoyFeedbackArray>());
         if(name == "/sensor_msgs/Image")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::Image>());
         if(name == "/sensor_msgs/NavSatFix")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::NavSatFix>());
         if(name == "/sensor_msgs/ChannelFloat32")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::ChannelFloat32>());
         if(name == "/sensor_msgs/TimeReference")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::TimeReference>());
         if(name == "/sensor_msgs/JointState")
              return ti->addProtocol(ORO_ROS_PROTOCOL_ID,new RosMsgTransporter<sensor_msgs::JointState>());

          return false;
      }
      
      std::string getTransportName() const {
          return "ros";
      }
      
      std::string getTypekitName() const {
          return std::string("ros-")+"sensor_msgs";
      }
      std::string getName() const {
          return std::string("rtt-ros-") + "sensor_msgs" + "-transport";
      }

    };
}

ORO_TYPEKIT_PLUGIN( ros_integration::ROSsensor_msgsPlugin )
